|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||
java.lang.Objectorg.opencms.workplace.CmsWorkplace
org.opencms.workplace.tools.CmsToolDialog
org.opencms.workplace.CmsDialog
org.opencms.workplace.editors.CmsEditor
org.opencms.workplace.editors.CmsDefaultPageEditor
public abstract class CmsDefaultPageEditor
Provides methods for building editors for the CmsDefaultPage page type.
Extend this class for all editors that work with the CmsDefaultPage.
| Field Summary | |
|---|---|
protected CmsFile |
m_file
File object used to read and write contents. |
protected CmsXmlPage |
m_page
Page object used from the action and init methods, be sure to initialize this e.g. |
static String |
PARAM_ELEMENTNAME
Parameter name for the request parameter "element name". |
static String |
PARAM_OLDELEMENTNAME
Parameter name for the request parameter "old element name". |
static String[] |
SELECTBOX_FONTS
option values for font select boxes. |
static String |
XML_BODY_ELEMENT
Name of the special body element from an XMLTemplate. |
| Fields inherited from class org.opencms.workplace.editors.CmsEditor |
|---|
ACTION_CHANGE_BODY, ACTION_EXIT, ACTION_PREVIEW, ACTION_SAVE, ACTION_SAVEACTION, ACTION_SAVEEXIT, ACTION_SHOW, ACTION_SHOW_ERRORMESSAGE, EDITOR_CHANGE_ELEMENT, EDITOR_CLEANUP, EDITOR_EXIT, EDITOR_PREVIEW, EDITOR_SAVE, EDITOR_SAVEACTION, EDITOR_SAVEEXIT, EDITOR_SHOW, EDITOR_SHOW_ERRORMESSAGE, PARAM_BACKLINK, PARAM_CONTENT, PARAM_DIRECTEDIT, PARAM_EDITASTEXT, PARAM_EDITORMODE, PARAM_ELEMENTLANGUAGE, PARAM_LOADDEFAULT, PARAM_MODIFIED, PARAM_OLDELEMENTLANGUAGE, PARAM_TEMPFILE, PATH_EDITORS |
| Fields inherited from class org.opencms.workplace.tools.CmsToolDialog |
|---|
PARAM_BASE, PARAM_PATH, PARAM_ROOT, PARAM_STYLE, STYLE_NEW |
| Constructor Summary | |
|---|---|
CmsDefaultPageEditor(CmsJspActionElement jsp)
Public constructor. |
|
| Method Summary | |
|---|---|
void |
actionChangeBodyElement()
Performs the change body action of the editor. |
void |
actionCleanupBodyElement()
Performs the cleanup body action of the editor. |
void |
actionClear(boolean forceUnlock)
Unlocks the edited resource when in direct edit mode or when the resource was not modified. |
void |
actionDirectEdit()
Performs a configurable action performed by the editor. |
void |
actionExit()
Performs the exit editor action and deletes the temporary file. |
void |
actionPreview()
Performs the preview page action in a new browser window. |
void |
actionSave()
Performs the save content action. |
abstract String |
buildGalleryButtons(CmsEditorDisplayOptions options,
int buttonStyle,
Properties displayOptions)
Builds the html String for the gallery buttons. |
String |
buildSelectElementLanguage(String attributes)
Builds the html String for the element language selector. |
String |
buildSelectElementName(String attributes)
Builds the html String for the element name selector. |
String |
buildSelectFonts(String attributes)
Builds the html for the font face select box of a WYSIWYG editor. |
void |
escapeParams()
Escapes the content and title parameters to display them in the editor form. |
protected List |
getElementList()
Returns the list of active elements of the page. |
Locale |
getElementLocale()
Returns the current element locale. |
String |
getParamElementname()
Returns the current element name. |
String |
getParamOldelementname()
Returns the old element name. |
String |
getUriStyleSheet()
Returns the OpenCms VFS uri of the style sheet of the current page. |
String |
getUriTemplate()
Returns the OpenCms VFS uri of the template of the current page. |
protected void |
initBodyElementLanguage()
Initializes the body element language for the first call of the editor. |
protected void |
initBodyElementName(String elementName)
Initializes the body element name of the editor. |
protected void |
initContent()
This method has to be called after initializing the body element name and language. |
protected void |
performSaveContent(String body,
Locale locale)
Saves the editor content to the temporary file. |
protected abstract String |
prepareContent(boolean save)
Manipulates the content String for different editor views and the save operation. |
void |
setParamElementname(String elementName)
Sets the current element name. |
void |
setParamOldelementname(String oldElementName)
Sets the old element name. |
| Methods inherited from class org.opencms.workplace.tools.CmsToolDialog |
|---|
dialogTitle, getAdminTool, getCurrentToolPath, getParamBase, getParamPath, getParamRoot, getParamStyle, getParentPath, getToolManager, iconsBlockArea, iconsBlockAreaEnd, iconsBlockAreaStart, initAdminTool, pageBody, pageHtmlStyle, setParamBase, setParamPath, setParamRoot, setParamStyle, useNewStyle |
| Methods inherited from class java.lang.Object |
|---|
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait |
| Field Detail |
|---|
public static final String PARAM_ELEMENTNAME
public static final String PARAM_OLDELEMENTNAME
public static final String XML_BODY_ELEMENT
protected CmsFile m_file
protected CmsXmlPage m_page
public static final String[] SELECTBOX_FONTS
| Constructor Detail |
|---|
public CmsDefaultPageEditor(CmsJspActionElement jsp)
jsp - an initialized JSP action element| Method Detail |
|---|
public void actionChangeBodyElement()
public void actionCleanupBodyElement()
public void actionClear(boolean forceUnlock)
CmsEditor
actionClear in class CmsEditorforceUnlock - if true, the resource will be unlocked anywayCmsEditor.actionClear(boolean)
public void actionDirectEdit()
throws IOException,
JspException,
ServletException
The default action is: save resource, clear temporary files and publish the resource directly.
IOException - if a forward fails
JspException - if including a JSP fails
ServletException - if a forward fails
public void actionExit()
throws IOException,
JspException,
ServletException
actionExit in class CmsEditorIOException - if a forward fails
JspException - if including an element fails
ServletException - if a forward failsCmsEditor.actionExit()
public void actionPreview()
throws IOException,
JspException
IOException - if redirect fails
JspException - if inclusion of error page fails
public void actionSave()
throws JspException
CmsEditor
actionSave in class CmsEditorJspException - if including an element failsCmsEditor.actionSave()
public abstract String buildGalleryButtons(CmsEditorDisplayOptions options,
int buttonStyle,
Properties displayOptions)
options - the display configuration for the editorbuttonStyle - the style for the buttonsdisplayOptions - the display options for the editor
public String buildSelectElementLanguage(String attributes)
attributes - optional attributes for the <select> tag
public String buildSelectElementName(String attributes)
attributes - optional attributes for the <select> tag
public String buildSelectFonts(String attributes)
attributes - optional attributes for the <select> tag
public void escapeParams()
This method has to be called on the JSP right before the form display html is created.
*
public Locale getElementLocale()
public String getParamElementname()
public String getParamOldelementname()
public String getUriStyleSheet()
public String getUriTemplate()
public void setParamElementname(String elementName)
elementName - the current element namepublic void setParamOldelementname(String oldElementName)
oldElementName - the old element nameprotected List getElementList()
protected void initBodyElementLanguage()
protected void initBodyElementName(String elementName)
This has to be called after the element language has been set with setParamBodylanguage().
elementName - the name of the element to initialize or null, if default element should be usedprotected void initContent()
initContent in class CmsEditorCmsEditor.initContent()
protected void performSaveContent(String body,
Locale locale)
throws CmsException
body - the body name to writelocale - the body locale to write
CmsException - if writing the file failsprotected abstract String prepareContent(boolean save)
save - if set to true, the result String is not escaped and the content parameter is not updated
|
||||||||||
| PREV CLASS NEXT CLASS | FRAMES NO FRAMES | |||||||||
| SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD | |||||||||